Index: moodle/lib/weblib.php
--- moodle/lib/weblib.php Base (1.1331)
+++ moodle/lib/weblib.php Locally Modified (Based On 1.1331)
@@ -2083,262 +2083,6 @@
 }
 
 /**
- * Prints breadcrumb trail of links, called in theme/-/header.html
- *
- * @global object
- * @global object
- * @global object
- * @uses CONTEXT_SYSTEM
- * @param mixed $navigation The breadcrumb navigation string to be printed
- * @param string $separator OBSOLETE, mostly not used any more. See build_navigation instead.
- * @param boolean $return False to echo the breadcrumb string (default), true to return it.
- * @return string|void String or null, depending on $return.
- */
-function print_navigation ($navigation, $separator=0, $return=false) {
-    global $CFG, $THEME, $SITE;
-    $output = '';
-
-    if (0 === $separator) {
-        $separator = get_separator();
-    }
-    else {
-        $separator = '<span class="sep">'. $separator .'</span>';
-    }
-
-    if ($navigation) {
-
-        if (is_newnav($navigation)) {
-            if ($return) {
-                return($navigation['navlinks']);
-            } else {
-                echo $navigation['navlinks'];
-                return;
-            }
-        } else {
-            debugging('Navigation needs to be updated to use build_navigation()', DEBUG_DEVELOPER);
-        }
-
-        if (!is_array($navigation)) {
-            $ar = explode('->', $navigation);
-            $navigation = array();
-
-            foreach ($ar as $a) {
-                if (strpos($a, '</a>') === false) {
-                    $navigation[] = array('title' => $a, 'url' => '');
-                } else {
-                    if (preg_match('/<a.*href="([^"]*)">(.*)<\/a>/', $a, $matches)) {
-                        $navigation[] = array('title' => $matches[2], 'url' => $matches[1]);
-                    }
-                }
-            }
-        }
-
-        if (!$SITE) {
-            $site = new object();
-            $site->shortname = get_string('home');
-        } else {
-            $site = $SITE;
-        }
-
-        //Accessibility: breadcrumb links now in a list, &raquo; replaced with a 'silent' character.
-        $output .= get_accesshide(get_string('youarehere','access'), 'h2')."<ul>\n";
-
-        $output .= '<li class="first">'."\n".'<a '.$CFG->frametarget.' onclick="this.target=\''.$CFG->framename.'\'" href="'
-               .$CFG->wwwroot.((!has_capability('moodle/site:config', get_context_instance(CONTEXT_SYSTEM))
-                                 && !empty($USER->id) && !empty($CFG->mymoodleredirect) && !isguest())
-                                 ? '/my' : '') .'/">'. format_string($site->shortname) ."</a>\n</li>\n";
-
-
-        foreach ($navigation as $navitem) {
-            $title = trim(strip_tags(format_string($navitem['title'], false)));
-            $url   = $navitem['url'];
-
-            if (empty($url)) {
-                $output .= '<li>'."$separator $title</li>\n";
-            } else {
-                $output .= '<li>'."$separator\n<a ".$CFG->frametarget.' onclick="this.target=\''.$CFG->framename.'\'" href="'
-                           .$url.'">'."$title</a>\n</li>\n";
-            }
-        }
-
-        $output .= "</ul>\n";
-    }
-
-    if ($return) {
-        return $output;
-    } else {
-        echo $output;
-    }
-}
-
-/**
- * This function will build the navigation string to be used by print_header
- * and others.
- *
- * It automatically generates the site and course level (if appropriate) links.
- *
- * If you pass in a $cm object, the method will also generate the activity (e.g. 'Forums')
- * and activityinstances (e.g. 'General Developer Forum') navigation levels.
- *
- * If you want to add any further navigation links after the ones this function generates,
- * the pass an array of extra link arrays like this:
- * array(
- *     array('name' => $linktext1, 'link' => $url1, 'type' => $linktype1),
- *     array('name' => $linktext2, 'link' => $url2, 'type' => $linktype2)
- * )
- * The normal case is to just add one further link, for example 'Editing forum' after
- * 'General Developer Forum', with no link.
- * To do that, you need to pass
- * array(array('name' => $linktext, 'link' => '', 'type' => 'title'))
- * However, becuase this is a very common case, you can use a shortcut syntax, and just
- * pass the string 'Editing forum', instead of an array as $extranavlinks.
- *
- * At the moment, the link types only have limited significance. Type 'activity' is
- * recognised in order to implement the $CFG->hideactivitytypenavlink feature. Types
- * that are known to appear are 'home', 'course', 'activity', 'activityinstance' and 'title'.
- * This really needs to be documented better. In the mean time, try to be consistent, it will
- * enable people to customise the navigation more in future.
- *
- * When passing a $cm object, the fields used are $cm->modname, $cm->name and $cm->course.
- * If you get the $cm object using the function get_coursemodule_from_instance or
- * get_coursemodule_from_id (as recommended) then this will be done for you automatically.
- * If you don't have $cm->modname or $cm->name, this fuction will attempt to find them using
- * the $cm->module and $cm->instance fields, but this takes extra database queries, so a
- * warning is printed in developer debug mode.
- *
- * @global object
- * @global object
- * @global object
- * @global object
- * @uses SITEID
- * @uses DEBUG_DEVELOPER
- * @uses CONTEXT_SYSTEM
- * @param mixed $extranavlinks - Normally an array of arrays, keys: name, link, type. If you
- *      only want one extra item with no link, you can pass a string instead. If you don't want
- *      any extra links, pass an empty string.
- * @param mixed $cm - optionally the $cm object, if you want this function to generate the
- *      activity and activityinstance levels of navigation too.
- * @return array Navigation array
- */
-function build_navigation($extranavlinks, $cm = null) {
-    global $CFG, $COURSE, $DB, $SITE;
-
-    if (is_string($extranavlinks)) {
-        if ($extranavlinks == '') {
-            $extranavlinks = array();
-        } else {
-            $extranavlinks = array(array('name' => $extranavlinks, 'link' => '', 'type' => 'title'));
-        }
-    }
-
-    $navlinks = array();
-
-    //Site name
-    if (!empty($SITE->shortname)) {
-        $navlinks[] = array(
-                'name' => format_string($SITE->shortname),
-                'link' => "$CFG->wwwroot/",
-                'type' => 'home');
-    }
-
-    // Course name, if appropriate.
-    if (isset($COURSE) && $COURSE->id != SITEID) {
-        $navlinks[] = array(
-                'name' => format_string($COURSE->shortname),
-                'link' => "$CFG->wwwroot/course/view.php?id=$COURSE->id",
-                'type' => 'course');
-    }
-
-    // Activity type and instance, if appropriate.
-    if (is_object($cm)) {
-        if (!isset($cm->modname)) {
-            debugging('The field $cm->modname should be set if you call build_navigation with '.
-                    'a $cm parameter. If you get $cm using get_coursemodule_from_instance or '.
-                    'get_coursemodule_from_id, this will be done automatically.', DEBUG_DEVELOPER);
-            if (!$cm->modname = $DB->get_field('modules', 'name', array('id'=>$cm->module))) {
-                print_error('cannotmoduletype');
-            }
-        }
-        if (!isset($cm->name)) {
-            debugging('The field $cm->name should be set if you call build_navigation with '.
-                    'a $cm parameter. If you get $cm using get_coursemodule_from_instance or '.
-                    'get_coursemodule_from_id, this will be done automatically.', DEBUG_DEVELOPER);
-            if (!$cm->name = $DB->get_field($cm->modname, 'name', array('id'=>$cm->instance))) {
-                print_error('cannotmodulename');
-            }
-        }
-        $navlinks[] = array(
-                'name' => get_string('modulenameplural', $cm->modname),
-                'link' => $CFG->wwwroot . '/mod/' . $cm->modname . '/index.php?id=' . $cm->course,
-                'type' => 'activity');
-        $navlinks[] = array(
-                'name' => format_string($cm->name),
-                'link' => $CFG->wwwroot . '/mod/' . $cm->modname . '/view.php?id=' . $cm->id,
-                'type' => 'activityinstance');
-    }
-
-    //Merge in extra navigation links
-    $navlinks = array_merge($navlinks, $extranavlinks);
-
-    // Work out whether we should be showing the activity (e.g. Forums) link.
-    // Note: build_navigation() is called from many places --
-    // install & upgrade for example -- where we cannot count on the
-    // roles infrastructure to be defined. Hence the during_initial_install() check.
-    if (!isset($CFG->hideactivitytypenavlink)) {
-        $CFG->hideactivitytypenavlink = 0;
-    }
-    if ($CFG->hideactivitytypenavlink == 2) {
-        $hideactivitylink = true;
-    } else if ($CFG->hideactivitytypenavlink == 1 && !during_initial_install() &&
-            !empty($COURSE->id) && $COURSE->id != SITEID) {
-        if (!isset($COURSE->context)) {
-            $COURSE->context = get_context_instance(CONTEXT_COURSE, $COURSE->id);
-        }
-        $hideactivitylink = !has_capability('moodle/course:manageactivities', $COURSE->context);
-    } else {
-        $hideactivitylink = false;
-    }
-
-    //Construct an unordered list from $navlinks
-    //Accessibility: heading hidden from visual browsers by default.
-    $navigation = get_accesshide(get_string('youarehere','access'), 'h2')." <ul>\n";
-    $lastindex = count($navlinks) - 1;
-    $i = -1; // Used to count the times, so we know when we get to the last item.
-    $first = true;
-    foreach ($navlinks as $navlink) {
-        $i++;
-        $last = ($i == $lastindex);
-        if (!is_array($navlink)) {
-            continue;
-        }
-        if (!empty($navlink['type']) && $navlink['type'] == 'activity' && !$last && $hideactivitylink) {
-            continue;
-        }
-        if ($first) {
-            $navigation .= '<li class="first">';
-        } else {
-            $navigation .= '<li>';
-        }
-        if (!$first) {
-            $navigation .= get_separator();
-        }
-        if ((!empty($navlink['link'])) && !$last) {
-            $navigation .= "<a onclick=\"this.target='$CFG->framename'\" href=\"{$navlink['link']}\">";
-        }
-        $navigation .= "{$navlink['name']}";
-        if ((!empty($navlink['link'])) && !$last) {
-            $navigation .= "</a>";
-        }
-
-        $navigation .= "</li>";
-        $first = false;
-    }
-    $navigation .= "</ul>";
-
-    return(array('newnav' => true, 'navlinks' => $navigation));
-}
-
-/**
  * Print (or return) a collapisble region, that has a caption that can
  * be clicked to expand or collapse the region.
  *
@@ -2677,165 +2421,6 @@
 }
 
 /**
- * Returns a small popup menu of course activity modules
- *
- * Given a course and a (current) coursemodule
- * his function returns a small popup menu with all the
- * course activity modules in it, as a navigation menu
- * The data is taken from the serialised array stored in
- * the course record
- *
- * @global object
- * @global object
- * @global object
- * @global object
- * @uses CONTEXT_COURSE
- * @param object $course A {@link $COURSE} object.
- * @param object $cm A {@link $COURSE} object.
- * @param string $targetwindow The target window attribute to us
- * @return string
- */
-function navmenu($course, $cm=NULL, $targetwindow='self') {
-    global $CFG, $THEME, $USER, $DB, $OUTPUT;
-    require_once($CFG->dirroot . '/course/lib.php'); // Required for get_fast_modinfo
-
-    if (empty($THEME->navmenuwidth)) {
-        $width = 50;
-    } else {
-        $width = $THEME->navmenuwidth;
-    }
-
-    if ($cm) {
-        $cm = $cm->id;
-    }
-
-    if ($course->format == 'weeks') {
-        $strsection = get_string('week');
-    } else {
-        $strsection = get_string('topic');
-    }
-    $strjumpto = get_string('jumpto');
-
-    $modinfo = get_fast_modinfo($course);
-    $context = get_context_instance(CONTEXT_COURSE, $course->id);
-
-    $section = -1;
-    $selected = '';
-    $url = '';
-    $previousmod = NULL;
-    $backmod = NULL;
-    $nextmod = NULL;
-    $selectmod = NULL;
-    $logslink = NULL;
-    $flag = false;
-    $menu = array();
-    $menustyle = array();
-
-    $sections = $DB->get_records('course_sections', array('course'=>$course->id), 'section', 'section,visible,summary');
-
-    if (!empty($THEME->makenavmenulist)) {   /// A hack to produce an XHTML navmenu list for use in themes
-        $THEME->navmenulist = navmenulist($course, $sections, $modinfo, $strsection, $strjumpto, $width, $cm);
-    }
-
-    foreach ($modinfo->cms as $mod) {
-        if ($mod->modname == 'label') {
-            continue;
-        }
-
-        if ($mod->sectionnum > $course->numsections) {   /// Don't show excess hidden sections
-            break;
-        }
-
-        if (!$mod->uservisible) { // do not icnlude empty sections at all
-            continue;
-        }
-
-        if ($mod->sectionnum > 0 and $section != $mod->sectionnum) {
-            $thissection = $sections[$mod->sectionnum];
-
-            if ($thissection->visible or !$course->hiddensections or
-                has_capability('moodle/course:viewhiddensections', $context)) {
-                $thissection->summary = strip_tags(format_string($thissection->summary,true));
-                if ($course->format == 'weeks' or empty($thissection->summary)) {
-                    $menu[] = '--'.$strsection ." ". $mod->sectionnum;
-                } else {
-                    if (strlen($thissection->summary) < ($width-3)) {
-                        $menu[] = '--'.$thissection->summary;
-                    } else {
-                        $menu[] = '--'.substr($thissection->summary, 0, $width).'...';
-                    }
-                }
-                $section = $mod->sectionnum;
-            } else {
-                // no activities from this hidden section shown
-                continue;
-            }
-        }
-
-        $url = $mod->modname.'/view.php?id='. $mod->id;
-        if ($flag) { // the current mod is the "next" mod
-            $nextmod = $mod;
-            $flag = false;
-        }
-        $localname = $mod->name;
-        if ($cm == $mod->id) {
-            $selected = $url;
-            $selectmod = $mod;
-            $backmod = $previousmod;
-            $flag = true; // set flag so we know to use next mod for "next"
-            $localname = $strjumpto;
-            $strjumpto = '';
-        } else {
-            $localname = strip_tags(format_string($localname,true));
-            $tl=textlib_get_instance();
-            if ($tl->strlen($localname) > ($width+5)) {
-                $localname = $tl->substr($localname, 0, $width).'...';
-            }
-            if (!$mod->visible) {
-                $localname = '('.$localname.')';
-            }
-        }
-        $menu[$url] = $localname;
-        if (empty($THEME->navmenuiconshide)) {
-            $menustyle[$url] = 'style="background-image: url('.$OUTPUT->mod_icon_url('icon', $mod->modname) . ');"';  // Unfortunately necessary to do this here
-        }
-        $previousmod = $mod;
-    }
-    //Accessibility: added Alt text, replaced &gt; &lt; with 'silent' character and 'accesshide' text.
-
-    if ($selectmod and has_capability('coursereport/log:view', $context)) {
-        $logstext = get_string('alllogs');
-        $logslink = '<li>'."\n".'<a title="'.$logstext.'" '.
-                    $CFG->frametarget.'onclick="this.target=\''.$CFG->framename.'\';"'.' href="'.
-                    $CFG->wwwroot.'/course/report/log/index.php?chooselog=1&amp;user=0&amp;date=0&amp;id='.
-                       $course->id.'&amp;modid='.$selectmod->id.'">'.
-                    '<img class="icon log" src="'.$OUTPUT->old_icon_url('i/log') . '" alt="'.$logstext.'" /></a>'."\n".'</li>';
-
-    }
-    if ($backmod) {
-        $backtext= get_string('activityprev', 'access');
-        $backmod = '<li><form action="'.$CFG->wwwroot.'/mod/'.$backmod->modname.'/view.php" '.
-                   'onclick="this.target=\''.$CFG->framename.'\';"'.'><fieldset class="invisiblefieldset">'.
-                   '<input type="hidden" name="id" value="'.$backmod->id.'" />'.
-                   '<button type="submit" title="'.$backtext.'">'.link_arrow_left($backtext, $url='', $accesshide=true).
-                   '</button></fieldset></form></li>';
-    }
-    if ($nextmod) {
-        $nexttext= get_string('activitynext', 'access');
-        $nextmod = '<li><form action="'.$CFG->wwwroot.'/mod/'.$nextmod->modname.'/view.php"  '.
-                   'onclick="this.target=\''.$CFG->framename.'\';"'.'><fieldset class="invisiblefieldset">'.
-                   '<input type="hidden" name="id" value="'.$nextmod->id.'" />'.
-                   '<button type="submit" title="'.$nexttext.'">'.link_arrow_right($nexttext, $url='', $accesshide=true).
-                   '</button></fieldset></form></li>';
-    }
-
-    return '<div class="navigation">'."\n".'<ul>'.$logslink . $backmod .
-            '<li>'.popup_form($CFG->wwwroot .'/mod/', $menu, 'navmenupopup', $selected, $strjumpto,
-                       '', '', true, $targetwindow, '', $menustyle).'</li>'.
-            $nextmod . '</ul>'."\n".'</div>';
-}
-
-/**
  * Returns a popup menu with course activity modules
  *
  * Given a course
Index: moodle/mod/forum/lib.php
--- moodle/mod/forum/lib.php Base (1.814)
+++ moodle/mod/forum/lib.php Locally Modified (Based On 1.814)
@@ -8177,3 +8177,180 @@
         return get_string('modulename', 'forum');
     }
 }
+
+/**
+ * This function is used to extend the global navigation by add forum nodes if there
+ * is relevant content.
+ *
+ * @param navigation_node $navref
+ * @param stdClass $course
+ * @param stdClass $module
+ * @param stdClass $cm
+ */
+function forum_extend_navigation($navref, $course, $module, $cm) {
+    global $CFG, $OUTPUT, $USER;
+
+    $limit = 5;
+    
+    $discussions = forum_get_discussions($cm,"d.timemodified DESC", false, -1, $limit);
+    $discussioncount = forum_get_discussions_count($cm);
+    if (!is_array($discussions) || count($discussions)==0) {
+        return;
+    }
+    $discussionkey = $navref->add(get_string('discussions', 'forum').' ('.$discussioncount.')');
+    $navref->get($discussionkey)->mainnavonly = true;
+
+    foreach ($discussions as $discussion) {
+        $icon = $OUTPUT->old_icon_url('i/feedback');
+        $url = new moodle_url($CFG->wwwroot.'/mod/forum/discuss.php', array('d'=>$discussion->discussion));
+        $navref->get($discussionkey)->add($discussion->subject, null, null, null, $url, $icon);
+    }
+
+    if ($discussioncount > count($discussions)) {
+        if (!empty($navref->action)) {
+            $url = $navref->action;
+        } else {
+            $url = new moodle_url($CFG->wwwroot.'/mod/forum/view.php', array('id'=>$cm->id));
+        }
+        $childkey = $navref->get($discussionkey)->add(get_string('viewalldiscussions', 'forum'), null, null, null, $url, $icon);
+    }
+
+    $index = 0;
+    $recentposts = array();
+    $lastlogin = time() - COURSE_MAX_RECENT_PERIOD;
+    if (!isguestuser() and !empty($USER->lastcourseaccess[$course->id])) {
+        if ($USER->lastcourseaccess[$course->id] > $lastlogin) {
+            $lastlogin = $USER->lastcourseaccess[$course->id];
+        }
+    }
+    forum_get_recent_mod_activity($recentposts, $index, $lastlogin, $course->id, $cm->id);
+
+    if (is_array($recentposts) && count($recentposts)>0) {
+        $recentkey = $navref->add(get_string('recentactivity').' ('.count($recentposts).')');
+        $navref->get($recentkey)->mainnavonly = true;
+        foreach ($recentposts as $post) {
+            $icon = $OUTPUT->old_icon_url('i/feedback');
+            $url = new moodle_url($CFG->wwwroot.'/mod/forum/discuss.php', array('d'=>$post->content->discussion));
+            $title = $post->content->subject."\n".userdate($post->timestamp, get_string('strftimerecent', 'langconfig'))."\n".$post->user->firstname.' '.$post->user->lastname;
+            $navref->get($recentkey)->add($title, null, null, null, $url, $icon);
+        }
+    }
+}
+
+/**
+ * This function is used to extend the settings navigation with settings for the module
+ * It is called when the context for the page is a forum module
+ *
+ * @param settings_navigation $settingsnav {@link settings_navigation}
+ * @param stdClass $module
+ * @return void|mixed The key to the modules branch
+ */
+function forum_extend_settings_navigation($settingsnav, $module=null) {
+    global $USER, $PAGE, $FULLME, $CFG, $DB, $OUTPUT;
+    $forumkey = $settingsnav->add(get_string('forumadministration', 'forum'));
+    $forum = $settingsnav->get($forumkey);
+    $forum->forceopen = true;
+
+    $forumobject = $DB->get_record("forum", array("id" => $PAGE->cm->instance));
+
+    if (!empty($USER->id) && !has_capability('moodle/legacy:guest', $PAGE->cm->context, NULL, false)) {
+        $notekey = false;
+        $helpbutton = false;
+        if (forum_is_forcesubscribed($forumobject)) {
+            $notekey = $forum->add(get_string("forcessubscribe", 'forum'));
+            $string = get_string('allowchoice', 'forum');
+            $helpbutton = new moodle_help_icon();
+            $helpbutton->page = "subscription";
+            $helpbutton->text = $string;
+            $helpbutton->module = "forum";
+            if (has_capability('mod/forum:managesubscriptions', $PAGE->cm->context)) {
+                $url = new moodle_url($CFG->wwwroot.'/mod/forum/subscribe.php', array('id'=>$forumobject->id, 'force'=>'no'));
+                $forum->add($string, null, null, settings_navigation::TYPE_SETTING, $url);
+            } else {
+                $forum->add(get_string('everyoneisnowsubscribed', 'forum'));
+            }
+        } else if ($forumobject->forcesubscribe == FORUM_DISALLOWSUBSCRIBE) {
+            $string = get_string('disallowsubscribe', 'forum');
+            $notekey = $forum->add($string);
+            $helpbutton = new moodle_help_icon();
+            $helpbutton->page = "subscription";
+            $helpbutton->text = $string;
+            $helpbutton->module = "forum";
+        } else {
+            $string = get_string("forcesubscribe", "forum");
+            $notekey = $forum->add(get_string("allowsallsubscribe", 'forum'));
+
+            $helpbutton = new moodle_help_icon();
+            $helpbutton->page = "subscription";
+            $helpbutton->text = $string;
+            $helpbutton->module = "forum";
+
+            if (has_capability('mod/forum:managesubscriptions', $PAGE->cm->context)) {
+                $url = new moodle_url($CFG->wwwroot.'/mod/forum/subscribe.php', array('id'=>$forumobject->id, 'force'=>'yes'));
+                $forum->add($string, null, null, settings_navigation::TYPE_SETTING, $url);
+            } else {
+                $forum->add(get_string('everyonecannowchoose', 'forum'));
+            }
+            if(has_capability('mod/forum:viewsubscribers', $PAGE->cm->context)){
+                $url = new moodle_url($CFG->wwwroot.'/mod/forum/subscribers.php', array('id'=>$forumobject->id));
+                $forum->add(get_string('showsubscribers', 'forum'), null, null, settings_navigation::TYPE_SETTING, $url);
+            }
+            
+            if (forum_is_forcesubscribed($forumobject) || ($forumobject->forcesubscribe == FORUM_DISALLOWSUBSCRIBE && !has_capability('mod/forum:managesubscriptions', $PAGE->cm->context))) {
+                // Do nothing
+            } else {
+                if (forum_is_subscribed($USER->id, $forumobject)) {
+                    $linktext = get_string('unsubscribe', 'forum');
+                } else {
+                    $linktext = get_string('subscribe', 'forum');
+                }
+                $url = new moodle_url($CFG->wwwroot . '/mod/forum/subscribe.php', array('id'=>$forumobject->id));
+                $forum->add($linktext, null, null, settings_navigation::TYPE_SETTING, $url);
+            }
+        }
+
+        if (forum_tp_can_track_forums($forumobject)) {
+            if (forum_tp_is_tracked($forumobject)) {
+                $linktext = get_string('notrackforum', 'forum');
+            } else {
+                $linktext = get_string('trackforum', 'forum');
+            }
+            $url = new moodle_url($CFG->wwwroot . '/mod/forum/settracking.php', array('id'=>$forumobject->id));
+            $forum->add($linktext, null, null, settings_navigation::TYPE_SETTING, $url);
+        }
+        if ($notekey!==false) {
+            $forum->get($notekey)->add_class('note');
+            if ($helpbutton!==false) {
+                $forum->get($notekey)->helpbutton = $OUTPUT->help_icon($helpbutton);
+            }
+        }
+        if (has_capability('moodle/course:manageactivities', $PAGE->cm->context)) {
+            $modulename = get_string('modulename', 'forum');
+            $string = get_string('updatethis', '', $modulename);
+            $url = new moodle_url("$CFG->wwwroot/course/mod.php", array('update' => $PAGE->cm->id, 'return' => true, 'sesskey' => sesskey()));
+            $forum->add($string, null, null, settings_navigation::TYPE_SETTING, $url);
+        }
+    }
+
+    if (!empty($CFG->enablerssfeeds) && !empty($CFG->forum_enablerssfeeds) && $forumobject->rsstype && $forumobject->rssarticles) {
+
+        if (!function_exists('rss_get_url')) {
+            require_once("$CFG->libdir/rsslib.php");
+        }
+
+        if ($forumobject->rsstype == 1) {
+            $string = get_string("rsssubscriberssdiscussions","forum",format_string($forumobject->name));
+        } else {
+            $string = get_string("rsssubscriberssposts","forum",format_string($forumobject->name));
+        }
+        if (empty($USER->id)) {
+            $userid = 0;
+        } else {
+            $userid = $USER->id;
+        }
+        $url = new moodle_url(rss_get_url($PAGE->course->id, $userid, "forum", $forumobject->id));
+        $forum->add($string, null, null, settings_navigation::TYPE_SETTING, $url, $OUTPUT->old_icon_url('i/rss'));
+    }
+
+    return $forumkey;
+}
Index: moodle/mod/forum/view.php
--- moodle/mod/forum/view.php Base (1.135)
+++ moodle/mod/forum/view.php Locally Modified (Based On 1.135)
@@ -42,8 +42,6 @@
         require_course_login($course, true, $cm);
         $strforums = get_string("modulenameplural", "forum");
         $strforum = get_string("modulename", "forum");
-        $PAGE->set_button(update_module_button($cm->id, $course->id, $strforum));
-
     } else if ($f) {
 
         if (! $forum = $DB->get_record("forum", array("id" => $f))) {
@@ -61,8 +59,6 @@
         require_course_login($course, true, $cm);
         $strforums = get_string("modulenameplural", "forum");
         $strforum = get_string("modulename", "forum");
-        $PAGE->set_button(update_module_button($cm->id, $course->id, $strforum));
-
     } else {
         print_error('missingparameter');
     }
@@ -76,10 +72,9 @@
 
 
 /// Print header.
-    $navigation = build_navigation('', $cm);
     $PAGE->set_title(format_string($forum->name));
     $PAGE->set_heading(format_string($course->fullname));
-    echo $OUTPUT->header($navigation, navmenu($course, $cm));
+    echo $OUTPUT->header(navmenu($course, $cm));
 
 /// Some capability checks.
     if (empty($cm->visible) and !has_capability('moodle/course:viewhiddenactivities', $context)) {
@@ -123,89 +118,6 @@
         }
     }
 
-
-//    print_box_start('forumcontrol clearfix');
-
-//    print_box_start('subscription clearfix');
-    echo '<div class="subscription">';
-
-    if (!empty($USER->id) && !has_capability('moodle/legacy:guest', $context, NULL, false)) {
-        $SESSION->fromdiscussion = "$FULLME";
-        if (forum_is_forcesubscribed($forum)) {
-            $streveryoneisnowsubscribed = get_string('everyoneisnowsubscribed', 'forum');
-            $strallowchoice = get_string('allowchoice', 'forum');
-            echo '<span class="helplink">' . get_string("forcessubscribe", 'forum') . '</span><br />';
-            echo $OUTPUT->help_icon(moodle_help_icon::make("subscription", $strallowchoice, "forum"));
-            echo '&nbsp;<span class="helplink">';
-            if (has_capability('mod/forum:managesubscriptions', $context)) {
-                echo "<a title=\"$strallowchoice\" href=\"subscribe.php?id=$forum->id&amp;force=no\">$strallowchoice</a>";
-            } else {
-                echo $streveryoneisnowsubscribed;
-            }
-            echo '</span><br />';
-
-        } else if ($forum->forcesubscribe == FORUM_DISALLOWSUBSCRIBE) {
-            $strsubscriptionsoff = get_string('disallowsubscribe','forum');
-            echo $strsubscriptionsoff;
-            echo $OUTPUT->help_icon(moodle_help_icon::make("subscription", $strsubscriptionsoff, "forum"));
-        } else {
-            $streveryonecannowchoose = get_string("everyonecannowchoose", "forum");
-            $strforcesubscribe = get_string("forcesubscribe", "forum");
-            $strshowsubscribers = get_string("showsubscribers", "forum");
-            echo '<span class="helplink">' . get_string("allowsallsubscribe", 'forum') . '</span><br />';
-            echo $OUTPUT->help_icon(moodle_help_icon::make("subscription", $strforcesubscribe, "forum"));
-            echo '&nbsp;';
-
-            if (has_capability('mod/forum:managesubscriptions', $context)) {
-                echo "<span class=\"helplink\"><a title=\"$strforcesubscribe\" href=\"subscribe.php?id=$forum->id&amp;force=yes\">$strforcesubscribe</a></span>";
-            } else {
-                echo '<span class="helplink">'.$streveryonecannowchoose.'</span>';
-            }
-
-            if(has_capability('mod/forum:viewsubscribers', $context)){
-                echo "<br />";
-                echo "<span class=\"helplink\"><a href=\"subscribers.php?id=$forum->id\">$strshowsubscribers</a></span>";
-            }
-
-            echo '<div class="helplink" id="subscriptionlink">', forum_get_subscribe_link($forum, $context,
-                    array('forcesubscribed' => '', 'cantsubscribe' => '')), '</div>';
-        }
-
-        if (forum_tp_can_track_forums($forum)) {
-            echo '<div class="helplink" id="trackinglink">'. forum_get_tracking_link($forum). '</div>';
-        }
-
-    }
-
-    /// If rss are activated at site and forum level and this forum has rss defined, show link
-    if (isset($CFG->enablerssfeeds) && isset($CFG->forum_enablerssfeeds) &&
-        $CFG->enablerssfeeds && $CFG->forum_enablerssfeeds && $forum->rsstype and $forum->rssarticles) {
-
-        if ($forum->rsstype == 1) {
-            $tooltiptext = get_string("rsssubscriberssdiscussions","forum",format_string($forum->name));
-        } else {
-            $tooltiptext = get_string("rsssubscriberssposts","forum",format_string($forum->name));
-        }
-        if (empty($USER->id)) {
-            $userid = 0;
-        } else {
-            $userid = $USER->id;
-        }
-//        print_box_start('rsslink');
-        echo '<span class="wrap rsslink">';
-        rss_print_link($course->id, $userid, "forum", $forum->id, $tooltiptext);
-        echo '</span>';
-//        print_box_end(); // subscription
-
-    }
-//    print_box_end(); // subscription
-    echo '</div>';
-
-//    print_box_end();  // forumcontrol
-
-//    print_box('&nbsp;', 'clearer');
-
-
     if (!empty($forum->blockafter) && !empty($forum->blockperiod)) {
         $a->blockafter = $forum->blockafter;
         $a->blockperiod = get_string('secondstotime'.$forum->blockperiod);
